<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="generator" content="pandoc">
  <meta name="author" content="Robert Detjens">
  <meta name="author" content="OSU LUG">
  <title>Pipewire + Linux Sound</title>
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/reset.css">
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/reveal.css">
  <style>
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    pre > code.sourceCode { white-space: pre; position: relative; }
    pre > code.sourceCode > span { display: inline-block; line-height: 1.25; }
    pre > code.sourceCode > span:empty { height: 1.2em; }
    .sourceCode { overflow: visible; }
    code.sourceCode > span { color: inherit; text-decoration: inherit; }
    div.sourceCode { margin: 1em 0; }
    pre.sourceCode { margin: 0; }
    @media screen {
    div.sourceCode { overflow: auto; }
    }
    @media print {
    pre > code.sourceCode { white-space: pre-wrap; }
    pre > code.sourceCode > span { text-indent: -5em; padding-left: 5em; }
    }
    pre.numberSource code
      { counter-reset: source-line 0; }
    pre.numberSource code > span
      { position: relative; left: -4em; counter-increment: source-line; }
    pre.numberSource code > span > a:first-child::before
      { content: counter(source-line);
        position: relative; left: -1em; text-align: right; vertical-align: baseline;
        border: none; display: inline-block;
        -webkit-touch-callout: none; -webkit-user-select: none;
        -khtml-user-select: none; -moz-user-select: none;
        -ms-user-select: none; user-select: none;
        padding: 0 4px; width: 4em;
        color: #aaaaaa;
      }
    pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
    div.sourceCode
      {   }
    @media screen {
    pre > code.sourceCode > span > a:first-child::before { text-decoration: underline; }
    }
    code span.al { color: #ff0000; font-weight: bold; } /* Alert */
    code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
    code span.at { color: #7d9029; } /* Attribute */
    code span.bn { color: #40a070; } /* BaseN */
    code span.bu { } /* BuiltIn */
    code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
    code span.ch { color: #4070a0; } /* Char */
    code span.cn { color: #880000; } /* Constant */
    code span.co { color: #60a0b0; font-style: italic; } /* Comment */
    code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
    code span.do { color: #ba2121; font-style: italic; } /* Documentation */
    code span.dt { color: #902000; } /* DataType */
    code span.dv { color: #40a070; } /* DecVal */
    code span.er { color: #ff0000; font-weight: bold; } /* Error */
    code span.ex { } /* Extension */
    code span.fl { color: #40a070; } /* Float */
    code span.fu { color: #06287e; } /* Function */
    code span.im { } /* Import */
    code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
    code span.kw { color: #007020; font-weight: bold; } /* Keyword */
    code span.op { color: #666666; } /* Operator */
    code span.ot { color: #007020; } /* Other */
    code span.pp { color: #bc7a00; } /* Preprocessor */
    code span.sc { color: #4070a0; } /* SpecialChar */
    code span.ss { color: #bb6688; } /* SpecialString */
    code span.st { color: #4070a0; } /* String */
    code span.va { color: #19177c; } /* Variable */
    code span.vs { color: #4070a0; } /* VerbatimString */
    code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/theme/white.css" id="theme">
</head>
<body>
  <div class="reveal">
    <div class="slides">

<section id="title-slide">
  <h1 class="title">Pipewire + Linux Sound</h1>
  <p class="author">Robert Detjens</p>
  <p class="author">OSU LUG</p>
  <p class="date">3/3/22</p>
</section>

<section id="sound-is-hard." class="title-slide slide level1">
<h1>Sound is hard.</h1>
<ul>
<li>Quality</li>
<li>Latency</li>
<li>Easy</li>
</ul>
</section>

<section id="history" class="title-slide slide level1">
<h1>History</h1>
<ul>
<li>OSS</li>
<li>ALSA</li>
<li>PulseAudio</li>
<li>JACK</li>
<li>Pipewire</li>
</ul>
</section>

<section>
<section id="in-the-beginning" class="title-slide slide level1">
<h1>In the beginning</h1>
<p>There was OSS</p>
</section>
<section id="open-sound-system" class="slide level2">
<h2>Open Sound System</h2>
<figure>
<img data-src="images/Creative-Sound-Blaster-16-ASP-16-bit-ISA-card-CT-1740.jpg" alt="Written for these sort of cards" /><figcaption aria-hidden="true">Written for these sort of cards</figcaption>
</figure>
</section>
<section id="open-sound-system-1" class="slide level2">
<h2>Open Sound System</h2>
<p>Available for every UNIX under the sun</p>
<p>Audio device driver, exposed as <code>/dev/dsp</code></p>
<div class="sourceCode" id="cb1"><pre class="sourceCode sh"><code class="sourceCode bash"><span id="cb1-1"><a href="#cb1-1" aria-hidden="true" tabindex="-1"></a><span class="fu">cat</span> /dev/random <span class="op">&gt;</span> /dev/dsp    <span class="co"># plays white noise through the speaker</span></span>
<span id="cb1-2"><a href="#cb1-2" aria-hidden="true" tabindex="-1"></a><span class="fu">cat</span> /dev/dsp <span class="op">&gt;</span> my_recording   <span class="co"># reads data from the microphone into a file</span></span></code></pre></div>
<p>Assumed hardware for mixing streams, which was less common</p>
<p>Userspace mixing libraries (<code>sdl</code>, <code>libao</code>)</p>
<p>Synchronous</p>
<p>OSS v4 went proprietary, v3 deprecated in kernel in favor of…</p>
</section></section>
<section>
<section id="alsa" class="title-slide slide level1">
<h1>ALSA</h1>
<p>Advanced Linux Sound Architecture</p>
<p><img data-src="https://alsa-project.org/main/images/alsalogo.gif" /></p>
</section>
<section id="alsa-1" class="slide level2">
<h2>ALSA</h2>
<p>Started in 1998</p>
<p>Introduced to kernel in 2.5.5 (2002)</p>
<p>Default in 2.6 (2003)</p>
</section>
<section id="alsa-2" class="slide level2">
<h2>ALSA</h2>
<ul>
<li>Allowed multiple cards, multiple devices</li>
<li>USB</li>
<li>MIDI</li>
<li>Software mixing (kinda sucked)</li>
<li>Complicated API (multi-threading!)</li>
<li>New drivers, buggy hardware</li>
<li>Worked alright for one app at a time</li>
</ul>
</section></section>
<section id="problems-with-alsa-oss" class="title-slide slide level1">
<h1>Problems with ALSA / OSS</h1>
<ul>
<li>work best with one client</li>
<li>mixing sucks</li>
<li>complicated</li>
<li>static</li>
<li>routing</li>
</ul>
</section>

<section>
<section id="pulseaudio" class="title-slide slide level1">
<h1>PulseAudio</h1>
<p><img data-src="https://www.freedesktop.org/software/pulseaudio/logo.png" /></p>
<p>another Poettering project!</p>
<p>Userspace <strong>sound server</strong></p>
<p>Runs on top of ALSA:</p>
<ul>
<li>things talk to PA</li>
<li>PA mixes/resamples to one stream</li>
<li>One stream sent to ALSA</li>
</ul>
</section>
<section id="benefits" class="slide level2">
<h2>Benefits</h2>
<ul>
<li>Better mixing</li>
<li>Resampling</li>
<li>Network transparency</li>
<li>Routing</li>
<li>App-level mixing</li>
<li>Bluetooth</li>
<li>GUI config</li>
</ul>
</section>
<section id="early-problems" class="slide level2">
<h2>Early problems</h2>
<ul>
<li>Yet another big API change</li>
<li>Buggy
<ul>
<li>timer-based scheduling</li>
<li>buffer ’flows</li>
</ul></li>
<li>Latency!</li>
<li>etc…</li>
</ul>
</section>
<section id="why" class="slide level2">
<h2>Why?</h2>
<ul>
<li>power usage
<ul>
<li>low latency || low power</li>
</ul></li>
<li>buggy drivers</li>
</ul>
</section></section>
<section>
<section id="jack" class="title-slide slide level1">
<h1>JACK</h1>
<p><img data-src="https://linuxaudio.github.io/libremusicproduction/html/sites/default/files/articles/Jacklogo.png" /></p>
<p>Pro audio focused audio server</p>
<p>Low low latency</p>
<p>Time sync</p>
<p>Plugins! DAW! MIDI!</p>
<p>Arbitrary connections, route anything into anything</p>
</section>
<section id="but" class="slide level2">
<h2>But…</h2>
<p>Not desktop focused</p>
<p>Needs more configuration</p>
<p>Manual routing</p>
</section></section>
<section>
<section id="the-new-player" class="title-slide slide level1">
<h1>The new player</h1>
<p><img data-src="https://upload.wikimedia.org/wikipedia/en/thumb/3/37/Pipewire_logo.svg/2880px-Pipewire_logo.svg.png" /></p>
</section>
<section id="pipewire" class="slide level2">
<h2>Pipewire</h2>
<p>Originally just for video streams in 2015</p>
<p>Video / webcams have similar problems as audio</p>
<p>“the PulseAudio for video”</p>
<p>Audio added in 2017/18</p>
</section>
<section id="improvements" class="slide level2">
<h2>Improvements</h2>
<p>Unification of A &amp; V</p>
<p>ACLs, Portal security</p>
<p>Generally smoother</p>
<p>Bluetooth is hassle-free!</p>
<p>Patchbay for plebians!</p>
</section>
<section id="how-to-get" class="slide level2">
<h2>How to get?</h2>
<p>Fedora 34+: ✅</p>
<p>Arch:</p>
<pre><code>pacman -Sy pipewire pipewire-alsa pipewire-pulse pipewire-jack wireplumber</code></pre>
<p><strong>Less supported:</strong></p>
<p>Debian 11: <a href="https://wiki.debian.org/PipeWire#Debian_11" class="uri">https://wiki.debian.org/PipeWire#Debian_11</a></p>
<p>Ubuntu 20.04: <a href="https://ubuntuhandbook.org/index.php/2022/04/pipewire-replace-pulseaudio-ubuntu-2204/" class="uri">https://ubuntuhandbook.org/index.php/2022/04/pipewire-replace-pulseaudio-ubuntu-2204/</a></p>
<p>Older Debian/Ubuntu: <a href="https://pipewire-debian.github.io/pipewire-debian/" class="uri">https://pipewire-debian.github.io/pipewire-debian/</a></p>
</section></section>
    </div>
  </div>

  <script src="https://unpkg.com/reveal.js@^4//dist/reveal.js"></script>

  <!-- reveal.js plugins -->
  <script src="https://unpkg.com/reveal.js@^4//plugin/notes/notes.js"></script>
  <script src="https://unpkg.com/reveal.js@^4//plugin/search/search.js"></script>
  <script src="https://unpkg.com/reveal.js@^4//plugin/zoom/zoom.js"></script>

  <script>

      // Full list of configuration options available at:
      // https://revealjs.com/config/
      Reveal.initialize({
        // Display controls in the bottom right corner
        controls: true,

        // Help the user learn the controls by providing hints, for example by
        // bouncing the down arrow when they first encounter a vertical slide
        controlsTutorial: true,

        // Determines where controls appear, "edges" or "bottom-right"
        controlsLayout: 'bottom-right',

        // Visibility rule for backwards navigation arrows; "faded", "hidden"
        // or "visible"
        controlsBackArrows: 'faded',

        // Display a presentation progress bar
        progress: true,

        // Display the page number of the current slide
        slideNumber: false,

        // 'all', 'print', or 'speaker'
        showSlideNumber: 'all',

        // Add the current slide number to the URL hash so that reloading the
        // page/copying the URL will return you to the same slide
        hash: true,

        // Start with 1 for the hash rather than 0
        hashOneBasedIndex: false,

        // Flags if we should monitor the hash and change slides accordingly
        respondToHashChanges: true,

        // Push each slide change to the browser history
        history: false,

        // Enable keyboard shortcuts for navigation
        keyboard: true,

        // Enable the slide overview mode
        overview: true,

        // Disables the default reveal.js slide layout (scaling and centering)
        // so that you can use custom CSS layout
        disableLayout: false,

        // Vertical centering of slides
        center: true,

        // Enables touch navigation on devices with touch input
        touch: true,

        // Loop the presentation
        loop: false,

        // Change the presentation direction to be RTL
        rtl: false,

        // see https://revealjs.com/vertical-slides/#navigation-mode
        navigationMode: 'default',

        // Randomizes the order of slides each time the presentation loads
        shuffle: false,

        // Turns fragments on and off globally
        fragments: true,

        // Flags whether to include the current fragment in the URL,
        // so that reloading brings you to the same fragment position
        fragmentInURL: true,

        // Flags if the presentation is running in an embedded mode,
        // i.e. contained within a limited portion of the screen
        embedded: false,

        // Flags if we should show a help overlay when the questionmark
        // key is pressed
        help: true,

        // Flags if it should be possible to pause the presentation (blackout)
        pause: true,

        // Flags if speaker notes should be visible to all viewers
        showNotes: false,

        // Global override for autoplaying embedded media (null/true/false)
        autoPlayMedia: null,

        // Global override for preloading lazy-loaded iframes (null/true/false)
        preloadIframes: null,

        // Number of milliseconds between automatically proceeding to the
        // next slide, disabled when set to 0, this value can be overwritten
        // by using a data-autoslide attribute on your slides
        autoSlide: 0,

        // Stop auto-sliding after user input
        autoSlideStoppable: true,

        // Use this method for navigation when auto-sliding
        autoSlideMethod: null,

        // Specify the average time in seconds that you think you will spend
        // presenting each slide. This is used to show a pacing timer in the
        // speaker view
        defaultTiming: null,

        // Enable slide navigation via mouse wheel
        mouseWheel: false,

        // The display mode that will be used to show slides
        display: 'block',

        // Hide cursor if inactive
        hideInactiveCursor: true,

        // Time before the cursor is hidden (in ms)
        hideCursorTime: 5000,

        // Opens links in an iframe preview overlay
        previewLinks: false,

        // Transition style (none/fade/slide/convex/concave/zoom)
        transition: 'slide',

        // Transition speed (default/fast/slow)
        transitionSpeed: 'default',

        // Transition style for full page slide backgrounds
        // (none/fade/slide/convex/concave/zoom)
        backgroundTransition: 'fade',

        // Number of slides away from the current that are visible
        viewDistance: 3,

        // Number of slides away from the current that are visible on mobile
        // devices. It is advisable to set this to a lower number than
        // viewDistance in order to save resources.
        mobileViewDistance: 2,

        // The "normal" size of the presentation, aspect ratio will be preserved
        // when the presentation is scaled to fit different resolutions. Can be
        // specified using percentage units.
        width: 1600,

        height: 1000,

        // reveal.js plugins
        plugins: [
          RevealNotes,
          RevealSearch,
          RevealZoom
        ]
      });
    </script>
    </body>
</html>
